
# Entity: ble_cdr 
- **File**: ble_cdr.sv

## Diagram
![Diagram](ble_cdr.svg "Diagram")
## Description

This file generated by [rtl-generator](https://github.com/burnettlab/rtl-generator.git), written by Brandon Hippe

## Generator Arguments

|   Argument   |  Value   |
| :----------: | :------: |
|  adc_width   |    4     |
|   clk_freq   | 16000000 |
|     fsym     | 1000000  |
| mf_clock_rec |   True   |

## Generics

| Generic name   | Type | Value | Description |
| -------------- | ---- | ----- | ----------- |
| SAMPLE_RATE    | int  | 16    |             |
| DATA_WIDTH     | int  | 4     |             |
| MAX_PACKET_LEN | int  | 376   |             |
| PREAMBLE_LEN   | int  | 8     |             |

## Ports

| Port name               | Direction | Type                              | Description |
| ----------------------- | --------- | --------------------------------- | ----------- |
| clk                     | input     |                                   |             |
| en                      | input     |                                   |             |
| resetn                  | input     |                                   |             |
| i_bpf                   | input     | [DATA_WIDTH-1:0]                  |             |
| q_bpf                   |           |                                   |             |
| demod_symbol            | output    |                                   |             |
| demod_symbol_clk        |           |                                   |             |
| modify_sniffer_settings | input     |                                   |             |
| acc_addr                | input     | [31:0]                            |             |
| channel                 | input     | [5:0]                             |             |
| packet_out              | output    | [MAX_PACKET_LEN-PREAMBLE_LEN-1:0] |             |
| packet_len              | output    | [clog2(MAX_PACKET_LEN)-1:0]       |             |
| packet_detected         | output    |                                   |             |

## Signals

| Name                | Type                                    | Description |
| ------------------- | --------------------------------------- | ----------- |
| demod_bit           | logic                                   |             |
| symbol_clk          | logic                                   |             |
| latched_acc_addr    | logic [31:0]                            |             |
| latched_channel     | logic [5:0]                             |             |
| packet_out_reg      | logic [MAX_PACKET_LEN-PREAMBLE_LEN-1:0] |             |
| packet_len_reg      | logic [clog2(MAX_PACKET_LEN)-1:0]       |             |
| packet_detected_reg | logic                                   |             |

## Constants

| Name            | Type | Value | Description |
| --------------- | ---- | ----- | ----------- |
| PIPELINE_STAGES |      | 1     |             |

## Processes
- unnamed: (  )
  - **Type:** always_comb
- unnamed: ( @(posedge clk or negedge resetn) )
  - **Type:** always_ff

## Instantiations

- mf: matched_filter
- cr: clock_recovery
- ps: packet_sniffer
