
# Entity: packet_sniffer 
- **File**: packet_sniffer.sv

## Diagram
![Diagram](packet_sniffer.svg "Diagram")
## Description

This file generated by [rtl-generator](https://github.com/burnettlab/rtl-generator.git), written by Brandon Hippe

## Generator Arguments

| Argument | Value |
| :------: | :---: |

## Generics

| Generic name   | Type | Value      | Description |
| -------------- | ---- | ---------- | ----------- |
| PACKET_LEN_MAX |      | 376        |             |
| PREAMBLE_LEN   |      | 8          |             |
| ACC_ADDR_LEN   |      | 32         |             |
| DEWHITEN_POLY  |      | 7'h04      |             |
| CRC_POLY       |      | 24'h00065A |             |
| CRC_INIT       |      | 24'h555555 |             |

## Ports

| Port name       | Direction | Type                              | Description |
| --------------- | --------- | --------------------------------- | ----------- |
| symbol_clk      | input     |                                   |             |
| resetn          |           |                                   |             |
| en              |           |                                   |             |
| symbol_in       | input     |                                   |             |
| packet_detected | output    |                                   |             |
| packet_out      | output    | [PACKET_LEN_MAX-PREAMBLE_LEN-1:0] |             |
| packet_len      | output    | [clog2(PACKET_LEN_MAX)-1:0]       |             |
| acc_addr        | input     | [ACC_ADDR_LEN-1:0]                |             |
| channel         | input     | [5:0]                             |             |

## Signals

| Name             | Type                              | Description |
| ---------------- | --------------------------------- | ----------- |
| rx_buffer        | logic [BUFFER_LEN-1:0]            |             |
| state            | logic                             |             |
| nextState        | logic                             |             |
| bit_counter      | logic [clog2(PACKET_LEN_MAX)-1:0] |             |
| acc_addr_matched | logic                             |             |
| packet_finished  | logic                             |             |
| dewhitened       | logic                             |             |
| crc_pass         | logic                             |             |

## Constants

| Name       | Type | Value                         | Description |
| ---------- | ---- | ----------------------------- | ----------- |
| BUFFER_LEN |      | PACKET_LEN_MAX - PREAMBLE_LEN |             |

## Processes
- unnamed: ( @(posedge symbol_clk or negedge resetn) )
  - **Type:** always_ff
- unnamed: ( @(posedge packet_detected or negedge resetn) )
  - **Type:** always_ff
- unnamed: (  )
  - **Type:** always_comb
- unnamed: ( @(negedge symbol_clk or negedge resetn) )
  - **Type:** always_ff
- unnamed: ( @(posedge symbol_clk or negedge resetn) )
  - **Type:** always_ff
- unnamed: ( @(posedge symbol_clk or negedge resetn) )
  - **Type:** always_ff

## Instantiations

- dw: dewhiten
- chk: crc
